%bcond_with wayland

%define _manifestdir %{TZ_SYS_RW_PACKAGES}
%define _desktop_icondir %{TZ_SYS_SHARE}/icons/default/small

%define crosswalk_extensions tizen-extensions-crosswalk

%define crosswalk_extensions_path %{_libdir}/%{crosswalk_extensions}

Name:       webapi-plugins-teec
Version:    0.1
Release:    0
License:    Apache-2.0
Group:      Development/Libraries
Summary:    Tizen Web plugin for TEF client library TEEC
Source0:    %{name}-%{version}.tar.gz

%ifarch %{arm} aarch64
# ARM
%define tizen_is_emulator           0
%else
# I586
%define tizen_is_emulator           1
%endif

BuildRequires: ninja
BuildRequires: pkgconfig(webapi-plugins)
BuildRequires: pkgconfig(tef-libteec)
BuildRequires: pkgconfig(capi-system-info)
BuildRequires: python

%description
Tizen TEF Framework Client API plugin

%prep
%setup -q

%build

export GYP_GENERATORS='ninja'
GYP_OPTIONS="--depth=. -Dtizen=1 -Dextension_build_type=Debug -Dextension_host_os=%{profile} -Dprivilege_engine=%{tizen_privilege_engine}"
GYP_OPTIONS="$GYP_OPTIONS -Ddisplay_type=%{display_type}"
GYP_OPTIONS="$GYP_OPTIONS -Dcrosswalk_extensions_path=%{crosswalk_extensions_path}"

# feature flags
GYP_OPTIONS="$GYP_OPTIONS -Dtizen_is_emulator=%{?tizen_is_emulator}"

/usr/include/webapi-plugins/tools/gyp/gyp $GYP_OPTIONS src/tizen-wrt.gyp

ninja -C out/Default %{?_smp_mflags}

%install

# Extensions.
mkdir -p %{buildroot}%{crosswalk_extensions_path}
install -p -m 644 ./out/Default/libtizen*.so %{buildroot}%{crosswalk_extensions_path}

# execute desc_gentool
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:%{buildroot}%{crosswalk_extensions_path} out/Default/desc_gentool \
  %{crosswalk_extensions_path} \
  %{buildroot}%{crosswalk_extensions_path} > teec_plugin.json

# temporary plugins description for lazy loading
install -p -m 644 teec_plugin.json %{buildroot}%{crosswalk_extensions_path}/teec_plugin.json

%post
#append ocal plugin.json to plugin.json of system
head %{crosswalk_extensions_path}/plugins.json -n -2 > tmp.json
echo  "    }," >> tmp.json
tail %{crosswalk_extensions_path}/teec_plugin.json -n +2 >> tmp.json
rm -f %{crosswalk_extensions_path}/plugins.json
mv -f tmp.json %{crosswalk_extensions_path}/plugins.json

%files
%{crosswalk_extensions_path}/libtizen*.so
%{crosswalk_extensions_path}/teec_plugin.json
%manifest plugins.manifest
%license LICENSE
