/**
 * Copyright (c) 2017-2021 Samsung Electronics Co., Ltd All Rights Reserved
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
/**
 * @file
 * @author Lukasz Kostyra (l.kostyra@samsung.com)
 * @brief  TeecSession class declaration
 */

#ifndef LIBTEEC_TEEC_SESSION_H_
#define LIBTEEC_TEEC_SESSION_H_

#include <string>
#include <memory>

#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#include <tee_client_api.h>

namespace extension {
namespace libteec {

class TeecSession final
{
public:
    TeecSession(TEEC_Context* ctx, const std::string& uuidstr,
                uint32_t connectionMethod, const void* connectionData,
                TEEC_Operation* operation, uint32_t* returnOrigin);
    ~TeecSession();

    void InvokeCommand(uint32_t cmd, TEEC_Operation* op, uint32_t* returnOrigin);

private:
    TEEC_Session mSession;
};

using TeecSessionPtr = std::shared_ptr<TeecSession>;

} // namespace libteec
} // namespace extension

#endif // LIBTEEC_TEEC_SESSION_H_