/*
 * Copyright (c) 2015 Samsung Electronics Co., Ltd All Rights Reserved
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */
/**
 * @file
 * @author Lukasz Kostyra (l.kostyra@samsung.com)
 * @brief  Libteec extension definitions
 */

#include "teec/libteec_extension.h"

#include "teec/libteec_instance.h"

// This will be generated from libteec_api.js
extern const char kSource_libteec_api[];

common::Extension* CreateExtension() {
    return new LibteecExtension;
}

LibteecExtension::LibteecExtension() {
    SetExtensionName("tizen.libteec");
    SetJavaScriptAPI(kSource_libteec_api);

    const char* entry_points[] = {
            "tizen.LibTeecManager",
            "tizen.TeecContext",
            "tizen.TeecSharedMemory",
            "tizen.TeecRegisteredMemory",
            "tizen.TeecTempMemory",
            "tizen.TeecValue",
            NULL
        };
    SetExtraJSEntryPoints(entry_points);
}

LibteecExtension::~LibteecExtension() {}

common::Instance* LibteecExtension::CreateInstance() {
    return new extension::libteec::LibteecInstance;
}